## lowdown 0.7.9

=== Makefile ===
.PHONY: regress
.SUFFIXES: .xml .md .html .pdf .1 .1.html .3 .3.html .5 .5.html .thumb.jpg .png .in.pc .pc

include Makefile.configure

VERSION		 = 0.7.9
OBJS		 = autolink.o \
		   buffer.o \
		   diff.o \
		   document.o \
		   entity.o \
		   gemini.o \
		   html.o \
		   html_escape.o \
		   latex.o \
		   library.o \
		   libdiff.o \
		   nroff.o \
		   smartypants.o \
		   term.o \
		   tree.o \
		   util.o \
		   xmalloc.o
COMPAT_OBJS	 = compats.o
WWWDIR		 = /var/www/vhosts/kristaps.bsd.lv/htdocs/lowdown
HTMLS		 = archive.html \
		   atom.xml \
		   diff.html \
		   diff.diff.html \
		   index.html \
		   README.html \
		   $(MANS)
MANS		 = man/lowdown.1.html \
		   man/lowdown.3.html \
		   man/lowdown.5.html \
		   man/lowdown_buf.3.html \
		   man/lowdown_buf_diff.3.html \
		   man/lowdown_buf_free.3.html \
		   man/lowdown_buf_new.3.html \
		   man/lowdown_diff.3.html \
		   man/lowdown_doc_free.3.html \
		   man/lowdown_doc_new.3.html \
		   man/lowdown_doc_parse.3.html \
		   man/lowdown_file.3.html \
		   man/lowdown_file_diff.3.html \
		   man/lowdown_gemini_free.3.html \
		   man/lowdown_gemini_new.3.html \
		   man/lowdown_gemini_rndr.3.html \
		   man/lowdown_html_free.3.html \
		   man/lowdown_html_new.3.html \
		   man/lowdown_html_rndr.3.html \
		   man/lowdown_latex_free.3.html \
		   man/lowdown_latex_new.3.html \
		   man/lowdown_latex_rndr.3.html \
		   man/lowdown_metaq_free.3.html \
		   man/lowdown_nroff_free.3.html \
		   man/lowdown_nroff_new.3.html \
		   man/lowdown_nroff_rndr.3.html \
		   man/lowdown_term_free.3.html \
		   man/lowdown_term_new.3.html \
		   man/lowdown_term_rndr.3.html \
		   man/lowdown_tree_free.3.html \
		   man/lowdown_tree_new.3.html \
		   man/lowdown_tree_rndr.3.html
SOURCES		 = autolink.c \
		   buffer.c \
		   compats.c \
		   diff.c \
		   document.c \
		   entity.c \
		   gemini.c \
		   html.c \
		   html_escape.c \
		   latex.c \
		   libdiff.c \
		   library.c \
		   log.c \
		   main.c \
		   nroff.c \
		   smartypants.c \
		   term.c \
		   tests.c \
		   tree.c \
		   util.c \
		   xmalloc.c
HEADERS 	 = extern.h \
		   libdiff.h \
		   lowdown.h
PDFS		 = diff.pdf \
		   index.pdf \
		   index.latex.pdf \
		   index.mandoc.pdf \
		   index.nroff.pdf
MDS		 = index.md README.md
CSSS		 = diff.css template.css
JSS		 = diff.js
IMAGES		 = screen-mandoc.png \
		   screen-groff.png \
		   screen-term.png
THUMBS		 = screen-mandoc.thumb.jpg \
		   screen-groff.thumb.jpg \
		   screen-term.thumb.jpg
REGRESS_ARGS	 = "--out-no-smarty"
REGRESS_ARGS	+= "--parse-no-img-ext"
REGRESS_ARGS	+= "--parse-no-metadata"
REGRESS_ARGS	+= "--html-no-head-ids"
REGRESS_ARGS	+= "--html-no-skiphtml"
REGRESS_ARGS	+= "--html-no-escapehtml"
REGRESS_ARGS	+= "--html-no-owasp"
REGRESS_ARGS	+= "--html-no-num-ent"
REGRESS_ARGS	+= "--parse-no-autolink"
REGRESS_ARGS	+= "--parse-no-cmark"
REGRESS_ARGS	+= "--parse-no-deflists"

all: lowdown lowdown-diff lowdown.pc

www: $(HTMLS) $(PDFS) $(THUMBS) lowdown.tar.gz lowdown.tar.gz.sha512

installwww: www
	mkdir -p $(WWWDIR)/snapshots
	$(INSTALL) -m 0444 $(THUMBS) $(IMAGES) $(MDS) $(HTMLS) $(CSSS) $(JSS) $(PDFS) $(WWWDIR)
	$(INSTALL) -m 0444 lowdown.tar.gz $(WWWDIR)/snapshots/lowdown-$(VERSION).tar.gz
	$(INSTALL) -m 0444 lowdown.tar.gz.sha512 $(WWWDIR)/snapshots/lowdown-$(VERSION).tar.gz.sha512
	$(INSTALL) -m 0444 lowdown.tar.gz $(WWWDIR)/snapshots
	$(INSTALL) -m 0444 lowdown.tar.gz.sha512 $(WWWDIR)/snapshots

lowdown: liblowdown.a main.o
	$(CC) -o $@ main.o liblowdown.a $(LDFLAGS) $(LDADD_MD5) -lm

lowdown-diff: lowdown
	ln -f lowdown lowdown-diff

liblowdown.a: $(OBJS) $(COMPAT_OBJS)
	$(AR) rs $@ $(OBJS) $(COMPAT_OBJS)

install: all
	mkdir -p $(DESTDIR)$(BINDIR)
	mkdir -p $(DESTDIR)$(LIBDIR)/pkgconfig
	mkdir -p $(DESTDIR)$(INCLUDEDIR)
	mkdir -p $(DESTDIR)$(MANDIR)/man1
	mkdir -p $(DESTDIR)$(MANDIR)/man3
	mkdir -p $(DESTDIR)$(MANDIR)/man5
	$(INSTALL_DATA) lowdown.pc $(DESTDIR)$(LIBDIR)/pkgconfig
	$(INSTALL_PROGRAM) lowdown $(DESTDIR)$(BINDIR)
	$(INSTALL_PROGRAM) lowdown-diff $(DESTDIR)$(BINDIR)
	$(INSTALL_LIB) liblowdown.a $(DESTDIR)$(LIBDIR)
	$(INSTALL_DATA) lowdown.h $(DESTDIR)$(INCLUDEDIR)
	for f in $(MANS) ; do \
		name=`basename $$f .html` ; \
		section=$${name##*.} ; \
		$(INSTALL_MAN) man/$$name $(DESTDIR)$(MANDIR)/man$$section ; \
	done

distcheck: lowdown.tar.gz.sha512
	mandoc -Tlint -Werror man/*.[135]
	newest=`grep "<h1>" versions.xml | tail -1 | sed 's![ 	]*!!g'` ; \
	       [ "$$newest" = "<h1>$(VERSION)</h1>" ] || \
		{ echo "Version $(VERSION) not newest in versions.xml" 1>&2 ; exit 1 ; }
	[ "`openssl dgst -sha512 -hex lowdown.tar.gz`" = "`cat lowdown.tar.gz.sha512`" ] || \
 		{ echo "Checksum does not match." 1>&2 ; exit 1 ; }
	rm -rf .distcheck
	mkdir -p .distcheck
	( cd .distcheck && tar -zvxpf ../lowdown.tar.gz )
	( cd .distcheck/lowdown-$(VERSION) && ./configure PREFIX=prefix )
	( cd .distcheck/lowdown-$(VERSION) && $(MAKE) )
	( cd .distcheck/lowdown-$(VERSION) && $(MAKE) regress )
	( cd .distcheck/lowdown-$(VERSION) && $(MAKE) install )
	rm -rf .distcheck

$(PDFS) index.xml README.xml: lowdown

index.html README.html: template.xml

.md.pdf:
	./lowdown --nroff-no-numbered -s -Tms $< | \
		pdfroff -i -mspdf -t -k -Kutf8 > $@

index.latex.pdf: index.md
	./lowdown -s -Tlatex README.md >index.latex.latex
	pdflatex index.latex.latex

index.mandoc.pdf: index.md
	./lowdown --nroff-no-numbered -s -Tman index.md | \
		mandoc -Tpdf > $@

index.nroff.pdf: index.md
	./lowdown --nroff-no-numbered -s -Tms index.md | \
		pdfroff -i -mspdf -t -k -Kutf8 > $@

.xml.html:
	sblg -t template.xml -s date -o $@ -C $< $< versions.xml

archive.html: archive.xml versions.xml
	sblg -t archive.xml -s date -o $@ versions.xml

atom.xml: atom-template.xml versions.xml
	sblg -a -t atom-template.xml -s date -o $@ versions.xml

diff.html: diff.md lowdown
	./lowdown -s diff.md >$@

diff.diff.html: diff.md diff.old.md lowdown-diff
	./lowdown-diff -s diff.old.md diff.md >$@

$(HTMLS): versions.xml

.md.xml: lowdown
	( echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" ; \
	  echo "<article data-sblg-article=\"1\">" ; \
	  ./lowdown $< ; \
	  echo "</article>" ; ) >$@

.1.1.html .3.3.html .5.5.html:
	mandoc -Thtml -Ostyle=https://bsd.lv/css/mandoc.css $< >$@

lowdown.tar.gz.sha512: lowdown.tar.gz
	openssl dgst -sha512 -hex lowdown.tar.gz >$@

lowdown.tar.gz:
	mkdir -p .dist/lowdown-$(VERSION)/
	mkdir -p .dist/lowdown-$(VERSION)/man
	mkdir -p .dist/lowdown-$(VERSION)/regress/smarty
	mkdir -p .dist/lowdown-$(VERSION)/regress/MarkdownTest_1.0.3
	$(INSTALL) -m 0644 $(HEADERS) .dist/lowdown-$(VERSION)
	$(INSTALL) -m 0644 $(SOURCES) .dist/lowdown-$(VERSION)
	$(INSTALL) -m 0644 lowdown.in.pc Makefile LICENSE.md .dist/lowdown-$(VERSION)
	$(INSTALL) -m 0644 man/*.1 man/*.3 man/*.5 .dist/lowdown-$(VERSION)/man
	$(INSTALL) -m 0755 configure .dist/lowdown-$(VERSION)
	$(INSTALL) -m 644 regress/MarkdownTest_1.0.3/*.text \
		.dist/lowdown-$(VERSION)/regress/MarkdownTest_1.0.3
	$(INSTALL) -m 644 regress/MarkdownTest_1.0.3/*.html \
		.dist/lowdown-$(VERSION)/regress/MarkdownTest_1.0.3
	$(INSTALL) -m 644 regress/smarty/*.md \
		.dist/lowdown-$(VERSION)/regress/smarty
	$(INSTALL) -m 644 regress/smarty/*.html \
		.dist/lowdown-$(VERSION)/regress/smarty
	( cd .dist/ && tar zcf ../$@ lowdown-$(VERSION) )
	rm -rf .dist/

$(OBJS) $(COMPAT_OBJS) main.o: config.h

$(OBJS): extern.h lowdown.h

main.o: lowdown.h

clean:
	rm -f $(OBJS) $(COMPAT_OBJS) main.o
	rm -f lowdown lowdown-diff liblowdown.a lowdown.pc
	rm -f index.xml diff.xml diff.diff.xml README.xml lowdown.tar.gz.sha512 lowdown.tar.gz
	rm -f $(PDFS) $(HTMLS) $(THUMBS)
	rm -f index.latex.aux index.latex.latex index.latex.log index.latex.out

distclean: clean
	rm -f Makefile.configure config.h config.log

regress: lowdown
	tmp1=`mktemp` ; \
	tmp2=`mktemp` ; \
	for f in regress/MarkdownTest_1.0.3/*.text ; \
	do \
		echo "$$f" ; \
		want="`dirname \"$$f\"`/`basename \"$$f\" .text`.html" ; \
		sed -e '/^[ ]*$$/d' "$$want" > $$tmp1 ; \
		./lowdown $(REGRESS_ARGS) "$$f" | \
			sed -e 's!	! !g' | sed -e '/^[ ]*$$/d' > $$tmp2 ; \
		diff -uw $$tmp1 $$tmp2 ; \
		./lowdown -s -Thtml "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Tlatex "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Tman "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Tms "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Tterm "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Ttree "$$f" >/dev/null 2>&1 ; \
	done  ; \
	for f in regress/smarty/*.md ; \
	do \
		echo "$$f" ; \
		./lowdown "$$f" > $$tmp1 ; \
		diff -uw `dirname $$f`/`basename $$f .md`.html $$tmp1 ; \
		./lowdown -s -Thtml "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Tlatex "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Tman "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Tms "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Tterm "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -Ttree "$$f" >/dev/null 2>&1 ; \
	done ; \
	rm -f $$tmp1 ; \
	rm -f $$tmp2

.png.thumb.jpg:
	convert $< -thumbnail 350 -quality 50 $@

.in.pc.pc:
	sed -e "s!@PREFIX@!$(PREFIX)!g" \
	    -e "s!@LIBDIR@!$(LIBDIR)!g" \
	    -e "s!@INCLUDEDIR@!$(INCLUDEDIR)!g" \
	    -e "s!@VERSION@!$(VERSION)!g" $< >$@

=== debian/changelog ===
lowdown (0.7.9-1) unstable; urgency=medium

  * New upstream release.
  * Add a (minimal) autopkgtest.

 -- Faidon Liambotis <paravoid@debian.org>  Mon, 01 Feb 2021 02:01:23 +0200

lowdown (0.7.7-1) unstable; urgency=medium

  * Initial release. (Closes: #896816)

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 08 Jan 2021 23:33:48 +0200

=== debian/control ===
Source: lowdown
Priority: optional
Maintainer: Faidon Liambotis <paravoid@debian.org>
Build-Depends:
  debhelper-compat (= 13),
  pkg-config,
  libbsd-dev,
  libmd-dev,
Standards-Version: 4.5.1
Section: text
Homepage: https://kristaps.bsd.lv/lowdown/
Vcs-Browser: https://salsa.debian.org/debian/lowdown
Vcs-Git: https://salsa.debian.org/debian/lowdown.git
Rules-Requires-Root: no

Package: lowdown
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple markdown translator
 Lowdown is a Markdown translator producing HTML5 and roff documents in the ms
 and man formats, LaTeX, gemini, and terminal output.
 .
 Beyond traditional Markdown syntax support, lowdown supports the following
 Markdown features and extensions:
  * autolinking
  * fenced code
  * tables
  * superscripts
  * footnotes
  * disabled inline HTML
  * “smart typography”
  * metadata
  * commonmark (in progress)
  * definition lists
  * extended image attributes

Package: liblowdown-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Description: Simple markdown translator (development files)
 Lowdown is a Markdown translator producing HTML5 and roff documents in the ms
 and man formats, LaTeX, gemini, and terminal output.
 .
 Beyond traditional Markdown syntax support, lowdown supports the following
 Markdown features and extensions:
  * autolinking
  * fenced code
  * tables
  * superscripts
  * footnotes
  * disabled inline HTML
  * “smart typography”
  * metadata
  * commonmark (in progress)
  * definition lists
  * extended image attributes
 .
 This package contains development libraries, header files, and manpages.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Use libbsd for a system copy of the BSD functions, instead of upstream's
# embedded compats.c coming from the oconfigure project.
# Also see https://github.com/kristapsdz/oconfigure/issues/19
CFLAGS += $(shell pkg-config --cflags libbsd-overlay)
LDFLAGS += $(shell pkg-config --libs libbsd-overlay)

%:
	dh $@

override_dh_auto_configure:
	CFLAGS="${CFLAGS}" \
	./configure \
		PREFIX=/usr \
		MANDIR="/usr/share/man" \
		LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} \
		CPPFLAGS="${CPPFLAGS}" \
		LDFLAGS="${LDFLAGS}"

override_dh_auto_test:
	make regress

override_dh_auto_clean:
	echo > Makefile.configure
	dh_auto_clean
	rm -f config.h.old config.log.old

## lowdown 0.8.0

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 include Makefile.configure
 
-VERSION		 = 0.7.9
+VERSION		 = 0.8.0
 OBJS		 = autolink.o \
 		   buffer.o \
 		   diff.o \
@@ -19,8 +19,7 @@
 		   smartypants.o \
 		   term.o \
 		   tree.o \
-		   util.o \
-		   xmalloc.o
+		   util.o
 COMPAT_OBJS	 = compats.o
 WWWDIR		 = /var/www/vhosts/kristaps.bsd.lv/htdocs/lowdown
 HTMLS		 = archive.html \
@@ -53,14 +52,13 @@
 		   man/lowdown_latex_new.3.html \
 		   man/lowdown_latex_rndr.3.html \
 		   man/lowdown_metaq_free.3.html \
+		   man/lowdown_node_free.3.html \
 		   man/lowdown_nroff_free.3.html \
 		   man/lowdown_nroff_new.3.html \
 		   man/lowdown_nroff_rndr.3.html \
 		   man/lowdown_term_free.3.html \
 		   man/lowdown_term_new.3.html \
 		   man/lowdown_term_rndr.3.html \
-		   man/lowdown_tree_free.3.html \
-		   man/lowdown_tree_new.3.html \
 		   man/lowdown_tree_rndr.3.html
 SOURCES		 = autolink.c \
 		   buffer.c \
@@ -74,19 +72,18 @@
 		   latex.c \
 		   libdiff.c \
 		   library.c \
-		   log.c \
 		   main.c \
 		   nroff.c \
 		   smartypants.c \
 		   term.c \
 		   tests.c \
 		   tree.c \
-		   util.c \
-		   xmalloc.c
+		   util.c
 HEADERS 	 = extern.h \
 		   libdiff.h \
 		   lowdown.h
 PDFS		 = diff.pdf \
+		   diff.diff.pdf \
 		   index.pdf \
 		   index.latex.pdf \
 		   index.mandoc.pdf \
@@ -173,10 +170,10 @@
 
 .md.pdf:
 	./lowdown --nroff-no-numbered -s -Tms $< | \
-		pdfroff -i -mspdf -t -k -Kutf8 > $@
-
-index.latex.pdf: index.md
-	./lowdown -s -Tlatex README.md >index.latex.latex
+		pdfroff -i -mspdf -t -k > $@
+
+index.latex.pdf: index.md $(THUMBS)
+	./lowdown -s -Tlatex index.md >index.latex.latex
 	pdflatex index.latex.latex
 
 index.mandoc.pdf: index.md
@@ -185,7 +182,7 @@
 
 index.nroff.pdf: index.md
 	./lowdown --nroff-no-numbered -s -Tms index.md | \
-		pdfroff -i -mspdf -t -k -Kutf8 > $@
+		pdfroff -i -mspdf -t -k > $@
 
 .xml.html:
 	sblg -t template.xml -s date -o $@ -C $< $< versions.xml
@@ -201,6 +198,10 @@
 
 diff.diff.html: diff.md diff.old.md lowdown-diff
 	./lowdown-diff -s diff.old.md diff.md >$@
+
+diff.diff.pdf: diff.md diff.old.md lowdown-diff
+	./lowdown-diff --nroff-no-numbered -s -Tms diff.old.md diff.md | \
+		pdfroff -i -mspdf -t -k > $@
 
 $(HTMLS): versions.xml

=== debian/changelog ===
lowdown (0.8.0-1) unstable; urgency=medium

  * New upstream release.

 -- Faidon Liambotis <paravoid@debian.org>  Wed, 03 Feb 2021 11:29:00 +0200

## lowdown 0.8.1

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 include Makefile.configure
 
-VERSION		 = 0.8.0
+VERSION		 = 0.8.1
 OBJS		 = autolink.o \
 		   buffer.o \
 		   diff.o \
@@ -84,7 +84,6 @@
 		   lowdown.h
 PDFS		 = diff.pdf \
 		   diff.diff.pdf \
-		   index.pdf \
 		   index.latex.pdf \
 		   index.mandoc.pdf \
 		   index.nroff.pdf
@@ -175,6 +174,7 @@
 index.latex.pdf: index.md $(THUMBS)
 	./lowdown -s -Tlatex index.md >index.latex.latex
 	pdflatex index.latex.latex
+	pdflatex index.latex.latex
 
 index.mandoc.pdf: index.md
 	./lowdown --nroff-no-numbered -s -Tman index.md | \
@@ -252,7 +252,7 @@
 	rm -f index.latex.aux index.latex.latex index.latex.log index.latex.out
 
 distclean: clean
-	rm -f Makefile.configure config.h config.log
+	rm -f Makefile.configure config.h config.log config.h.old config.log.old
 
 regress: lowdown
 	tmp1=`mktemp` ; \

=== debian/changelog ===
lowdown (0.8.1-1) unstable; urgency=medium

  * New upstream release.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 09 Feb 2021 13:40:33 +0200

## lowdown 0.8.2

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 include Makefile.configure
 
-VERSION		 = 0.8.1
+VERSION		 = 0.8.2
 OBJS		 = autolink.o \
 		   buffer.o \
 		   diff.o \
@@ -32,6 +32,7 @@
 MANS		 = man/lowdown.1.html \
 		   man/lowdown.3.html \
 		   man/lowdown.5.html \
+		   man/lowdown-diff.1.html \
 		   man/lowdown_buf.3.html \
 		   man/lowdown_buf_diff.3.html \
 		   man/lowdown_buf_free.3.html \

=== debian/changelog ===
lowdown (0.8.2-1) unstable; urgency=medium

  * New upstream release.
    - Now ships with a separate manpage for lowdown-diff.

 -- Faidon Liambotis <paravoid@debian.org>  Sat, 20 Feb 2021 14:34:49 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Priority: optional
 Maintainer: Faidon Liambotis <paravoid@debian.org>
 Build-Depends:
-  debhelper-compat (= 13),
-  pkg-config,
-  libbsd-dev,
-  libmd-dev,
+ debhelper-compat (= 13),
+ libbsd-dev,
+ libmd-dev,
+ pkg-config,
 Standards-Version: 4.5.1
 Section: text
 Homepage: https://kristaps.bsd.lv/lowdown/
@@ -17,8 +17,8 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Simple markdown translator
- Lowdown is a Markdown translator producing HTML5 and roff documents in the ms
- and man formats, LaTeX, gemini, and terminal output.
+ Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
+ man formats, LaTeX, gemini, and terminal output.
  .
  Beyond traditional Markdown syntax support, lowdown supports the following
  Markdown features and extensions:
@@ -40,8 +40,8 @@
 Multi-Arch: same
 Depends: ${misc:Depends}
 Description: Simple markdown translator (development files)
- Lowdown is a Markdown translator producing HTML5 and roff documents in the ms
- and man formats, LaTeX, gemini, and terminal output.
+ Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
+ man formats, LaTeX, gemini, and terminal output.
  .
  Beyond traditional Markdown syntax support, lowdown supports the following
  Markdown features and extensions:

=== debian/tests/control ===
Test-Command: lowdown LICENSE.md

=== debian/watch ===
version=4
https://kristaps.bsd.lv/lowdown/snapshots/ \
  lowdown-([\d\.]+)\.tar\.gz debian uupdate

## lowdown 0.10.0

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 include Makefile.configure
 
-VERSION		 = 0.8.2
+VERSION		 = 0.10.0
 OBJS		 = autolink.o \
 		   buffer.o \
 		   diff.o \
@@ -16,6 +16,7 @@
 		   library.o \
 		   libdiff.o \
 		   nroff.o \
+		   odt.o \
 		   smartypants.o \
 		   term.o \
 		   tree.o \
@@ -57,6 +58,9 @@
 		   man/lowdown_nroff_free.3.html \
 		   man/lowdown_nroff_new.3.html \
 		   man/lowdown_nroff_rndr.3.html \
+		   man/lowdown_odt_free.3.html \
+		   man/lowdown_odt_new.3.html \
+		   man/lowdown_odt_rndr.3.html \
 		   man/lowdown_term_free.3.html \
 		   man/lowdown_term_new.3.html \
 		   man/lowdown_term_rndr.3.html \
@@ -75,6 +79,7 @@
 		   library.c \
 		   main.c \
 		   nroff.c \
+		   odt.c \
 		   smartypants.c \
 		   term.c \
 		   tests.c \
@@ -82,7 +87,8 @@
 		   util.c
 HEADERS 	 = extern.h \
 		   libdiff.h \
-		   lowdown.h
+		   lowdown.h \
+		   term.h
 PDFS		 = diff.pdf \
 		   diff.diff.pdf \
 		   index.latex.pdf \
@@ -97,6 +103,9 @@
 THUMBS		 = screen-mandoc.thumb.jpg \
 		   screen-groff.thumb.jpg \
 		   screen-term.thumb.jpg
+
+# Only for MarkdownTestv1.0.3.
+
 REGRESS_ARGS	 = "--out-no-smarty"
 REGRESS_ARGS	+= "--parse-no-img-ext"
 REGRESS_ARGS	+= "--parse-no-metadata"
@@ -221,7 +230,6 @@
 lowdown.tar.gz:
 	mkdir -p .dist/lowdown-$(VERSION)/
 	mkdir -p .dist/lowdown-$(VERSION)/man
-	mkdir -p .dist/lowdown-$(VERSION)/regress/smarty
 	mkdir -p .dist/lowdown-$(VERSION)/regress/MarkdownTest_1.0.3
 	$(INSTALL) -m 0644 $(HEADERS) .dist/lowdown-$(VERSION)
 	$(INSTALL) -m 0644 $(SOURCES) .dist/lowdown-$(VERSION)
@@ -230,18 +238,30 @@
 	$(INSTALL) -m 0755 configure .dist/lowdown-$(VERSION)
 	$(INSTALL) -m 644 regress/MarkdownTest_1.0.3/*.text \
 		.dist/lowdown-$(VERSION)/regress/MarkdownTest_1.0.3
+	$(INSTALL) -m 644 regress/MarkdownTest_1.0.3/*.md \
+		.dist/lowdown-$(VERSION)/regress/MarkdownTest_1.0.3
 	$(INSTALL) -m 644 regress/MarkdownTest_1.0.3/*.html \
 		.dist/lowdown-$(VERSION)/regress/MarkdownTest_1.0.3
-	$(INSTALL) -m 644 regress/smarty/*.md \
-		.dist/lowdown-$(VERSION)/regress/smarty
-	$(INSTALL) -m 644 regress/smarty/*.html \
-		.dist/lowdown-$(VERSION)/regress/smarty
+	$(INSTALL) -m 644 regress/*.md \
+		.dist/lowdown-$(VERSION)/regress
+	$(INSTALL) -m 644 regress/*.html \
+		.dist/lowdown-$(VERSION)/regress
+	$(INSTALL) -m 644 regress/*.ms \
+		.dist/lowdown-$(VERSION)/regress
+	$(INSTALL) -m 644 regress/*.man \
+		.dist/lowdown-$(VERSION)/regress
+	$(INSTALL) -m 644 regress/*.latex \
+		.dist/lowdown-$(VERSION)/regress
+	$(INSTALL) -m 644 regress/*.gemini \
+		.dist/lowdown-$(VERSION)/regress
 	( cd .dist/ && tar zcf ../$@ lowdown-$(VERSION) )
 	rm -rf .dist/
 
 $(OBJS) $(COMPAT_OBJS) main.o: config.h
 
 $(OBJS): extern.h lowdown.h
+
+term.o: term.h
 
 main.o: lowdown.h
 
@@ -258,8 +278,7 @@
 regress: lowdown
 	tmp1=`mktemp` ; \
 	tmp2=`mktemp` ; \
-	for f in regress/MarkdownTest_1.0.3/*.text ; \
-	do \
+	for f in regress/MarkdownTest_1.0.3/*.text ; do \
 		echo "$$f" ; \
 		want="`dirname \"$$f\"`/`basename \"$$f\" .text`.html" ; \
 		sed -e '/^[ ]*$$/d' "$$want" > $$tmp1 ; \
@@ -270,20 +289,62 @@
 		./lowdown -s -Tlatex "$$f" >/dev/null 2>&1 ; \
 		./lowdown -s -Tman "$$f" >/dev/null 2>&1 ; \
 		./lowdown -s -Tms "$$f" >/dev/null 2>&1 ; \
+		./lowdown -s -Tfodt "$$f" >/dev/null 2>&1 ; \
 		./lowdown -s -Tterm "$$f" >/dev/null 2>&1 ; \
 		./lowdown -s -Ttree "$$f" >/dev/null 2>&1 ; \
 	done  ; \
-	for f in regress/smarty/*.md ; \
-	do \
+	for f in regress/*.md ; do \
 		echo "$$f" ; \
-		./lowdown "$$f" > $$tmp1 ; \
-		diff -uw `dirname $$f`/`basename $$f .md`.html $$tmp1 ; \
-		./lowdown -s -Thtml "$$f" >/dev/null 2>&1 ; \
-		./lowdown -s -Tlatex "$$f" >/dev/null 2>&1 ; \
-		./lowdown -s -Tman "$$f" >/dev/null 2>&1 ; \
-		./lowdown -s -Tms "$$f" >/dev/null 2>&1 ; \
-		./lowdown -s -Tterm "$$f" >/dev/null 2>&1 ; \
-		./lowdown -s -Ttree "$$f" >/dev/null 2>&1 ; \
+		if [ -f regress/`basename $$f .md`.html ]; then \
+			./lowdown -Thtml $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/`basename $$f .md`.html $$tmp1 ; \
+		fi ; \
+		if [ -f regress/`basename $$f .md`.latex ]; then \
+			./lowdown -Tlatex $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/`basename $$f .md`.latex $$tmp1 ; \
+		fi ; \
+		if [ -f regress/`basename $$f .md`.ms ]; then \
+			./lowdown -Tms $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/`basename $$f .md`.ms $$tmp1 ; \
+		fi ; \
+		if [ -f regress/`basename $$f .md`.man ]; then \
+			./lowdown -Tman $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/`basename $$f .md`.man $$tmp1 ; \
+		fi ; \
+		if [ -f regress/`basename $$f .md`.gemini ]; then \
+			./lowdown -Tgemini $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/`basename $$f .md`.gemini $$tmp1 ; \
+		fi ; \
+	done ; \
+	for f in regress/standalone/*.md ; do \
+		echo "$$f" ; \
+		if [ -f regress/standalone/`basename $$f .md`.html ]; then \
+			./lowdown -s -Thtml $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/standalone/`basename $$f .md`.html $$tmp1 ; \
+		fi ; \
+		if [ -f regress/standalone/`basename $$f .md`.latex ]; then \
+			./lowdown -s -Tlatex $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/standalone/`basename $$f .md`.latex $$tmp1 ; \
+		fi ; \
+		if [ -f regress/standalone/`basename $$f .md`.ms ]; then \
+			./lowdown -s -Tms $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/standalone/`basename $$f .md`.ms $$tmp1 ; \
+		fi ; \
+		if [ -f regress/standalone/`basename $$f .md`.man ]; then \
+			./lowdown -s -Tman $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/standalone/`basename $$f .md`.man $$tmp1 ; \
+		fi ; \
+		if [ -f regress/standalone/`basename $$f .md`.gemini ]; then \
+			./lowdown -s -Tgemini $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/standalone/`basename $$f .md`.gemini $$tmp1 ; \
+		fi ; \
+	done ; \
+	for f in regress/metadata/*.md ; do \
+		echo "$$f" ; \
+		if [ -f regress/metadata/`basename $$f .md`.txt ]; then \
+			./lowdown -X test $$f >$$tmp1 2>&1 ; \
+			diff -uw regress/metadata/`basename $$f .md`.txt $$tmp1 ; \
+		fi ; \
 	done ; \
 	rm -f $$tmp1 ; \
 	rm -f $$tmp2

=== debian/changelog ===
lowdown (0.10.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.0, no changes needed.

 -- Faidon Liambotis <paravoid@debian.org>  Sat, 13 Nov 2021 16:47:41 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  libbsd-dev,
  libmd-dev,
  pkg-config,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Section: text
 Homepage: https://kristaps.bsd.lv/lowdown/
 Vcs-Browser: https://salsa.debian.org/debian/lowdown

=== debian/rules ===
--- 
+++ 
@@ -31,4 +31,3 @@
 override_dh_auto_clean:
 	echo > Makefile.configure
 	dh_auto_clean
-	rm -f config.h.old config.log.old

## lowdown 1.0.0

=== Makefile ===
.PHONY: regress
.SUFFIXES: .xml .md .html .pdf .1 .1.html .3 .3.html .5 .5.html .thumb.jpg .png .in.pc .pc .valgrind .old.md .diff-valgrind

include Makefile.configure

VERSION		 = 1.0.0
LIBVER		 = 1
OBJS		 = autolink.o \
		   buffer.o \
		   diff.o \
		   document.o \
		   entity.o \
		   gemini.o \
		   html.o \
		   html_escape.o \
		   latex.o \
		   library.o \
		   libdiff.o \
		   nroff.o \
		   odt.o \
		   smartypants.o \
		   term.o \
		   tree.o \
		   util.o
COMPAT_OBJS	 = compats.o
WWWDIR		 = /var/www/vhosts/kristaps.bsd.lv/htdocs/lowdown
HTMLS		 = archive.html \
		   atom.xml \
		   diff.html \
		   diff.diff.html \
		   index.html \
		   README.html \
		   $(MANS)
MANS		 = $(MAN1S) $(MAN3S) $(MAN5S)
MAN1S		 = man/lowdown.1.html \
		   man/lowdown-diff.1.html
MAN5S =  	   man/lowdown.5.html
MAN3S = 	   man/lowdown.3.html \
		   man/lowdown_buf.3.html \
		   man/lowdown_buf_diff.3.html \
		   man/lowdown_buf_free.3.html \
		   man/lowdown_buf_new.3.html \
		   man/lowdown_diff.3.html \
		   man/lowdown_doc_free.3.html \
		   man/lowdown_doc_new.3.html \
		   man/lowdown_doc_parse.3.html \
		   man/lowdown_file.3.html \
		   man/lowdown_file_diff.3.html \
		   man/lowdown_gemini_free.3.html \
		   man/lowdown_gemini_new.3.html \
		   man/lowdown_gemini_rndr.3.html \
		   man/lowdown_html_free.3.html \
		   man/lowdown_html_new.3.html \
		   man/lowdown_html_rndr.3.html \
		   man/lowdown_latex_free.3.html \
		   man/lowdown_latex_new.3.html \
		   man/lowdown_latex_rndr.3.html \
		   man/lowdown_metaq_free.3.html \
		   man/lowdown_node_free.3.html \
		   man/lowdown_nroff_free.3.html \
		   man/lowdown_nroff_new.3.html \
		   man/lowdown_nroff_rndr.3.html \
		   man/lowdown_odt_free.3.html \
		   man/lowdown_odt_new.3.html \
		   man/lowdown_odt_rndr.3.html \
		   man/lowdown_term_free.3.html \
		   man/lowdown_term_new.3.html \
		   man/lowdown_term_rndr.3.html \
		   man/lowdown_tree_rndr.3.html
SOURCES		 = autolink.c \
		   buffer.c \
		   compats.c \
		   diff.c \
		   document.c \
		   entity.c \
		   gemini.c \
		   html.c \
		   html_escape.c \
		   latex.c \
		   libdiff.c \
		   library.c \
		   main.c \
		   nroff.c \
		   odt.c \
		   smartypants.c \
		   term.c \
		   tests.c \
		   tree.c \
		   util.c
HEADERS 	 = extern.h \
		   libdiff.h \
		   lowdown.h \
		   term.h
PDFS		 = diff.pdf \
		   diff.diff.pdf \
		   index.latex.pdf \
		   index.mandoc.pdf \
		   index.nroff.pdf
MDS		 = index.md README.md
CSSS		 = diff.css template.css
JSS		 = diff.js
IMAGES		 = screen-mandoc.png \
		   screen-groff.png \
		   screen-term.png
THUMBS		 = screen-mandoc.thumb.jpg \
		   screen-groff.thumb.jpg \
		   screen-term.thumb.jpg
VALGRINDS	!= for f in `find regress -name \*.md` ; do echo `dirname $$f`/`basename $$f .md`.valgrind ; done
VALGRINDDIFFS	!= for f in `find regress/diff -name \*.old.md` ; do echo `dirname $$f`/`basename $$f .old.md`.diff-valgrind ; done
CFLAGS		+= -fPIC

# Only for MarkdownTestv1.0.3 in regress/original.

REGRESS_ARGS	 = "--out-no-smarty"
REGRESS_ARGS	+= "--parse-no-img-ext"
REGRESS_ARGS	+= "--parse-no-metadata"
REGRESS_ARGS	+= "--html-no-head-ids"
REGRESS_ARGS	+= "--html-no-skiphtml"
REGRESS_ARGS	+= "--html-no-escapehtml"
REGRESS_ARGS	+= "--html-no-owasp"
REGRESS_ARGS	+= "--html-no-num-ent"
REGRESS_ARGS	+= "--parse-no-autolink"
REGRESS_ARGS	+= "--parse-no-cmark"
REGRESS_ARGS	+= "--parse-no-deflists"

VALGRIND_ARGS	 = -q --leak-check=full --leak-resolution=high --show-reachable=yes

all: bins lowdown.pc liblowdown.so
bins: lowdown lowdown-diff

valgrind: $(VALGRINDS) $(VALGRINDDIFFS)
	@for f in $(VALGRINDS) ; do \
		if [ -s $$f ]; then \
			echo `dirname $$f`/`basename $$f .valgrind`.md ; \
			cat $$f ; \
		fi ; \
	done
	@for f in $(VALGRINDDIFFS) ; do \
		if [ -s $$f ]; then \
			echo `dirname $$f`/`basename $$f .diff-valgrind`.old.md ; \
			cat $$f ; \
		fi ; \
	done

$(VALGRINDS) $(VALGRINDDIFFS): bins

.old.md.diff-valgrind:
	@rm -f $@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tfodt $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -thtml $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tms $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tman $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tterm $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown-diff -s -tgemini $< `dirname $<`/`basename $< .old.md`.new.md >/dev/null 2>>$@

.md.valgrind:
	@rm -f $@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tfodt $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -thtml $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tms $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tman $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tterm $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tgemini $< >/dev/null 2>>$@
	valgrind $(VALGRIND_ARGS) ./lowdown -s -tlatex $< >/dev/null 2>>$@

www: all $(HTMLS) $(PDFS) $(THUMBS) lowdown.tar.gz lowdown.tar.gz.sha512

installwww: www
	mkdir -p $(WWWDIR)/snapshots
	$(INSTALL) -m 0444 $(THUMBS) $(IMAGES) $(MDS) $(HTMLS) $(CSSS) $(JSS) $(PDFS) $(WWWDIR)
	$(INSTALL) -m 0444 lowdown.tar.gz $(WWWDIR)/snapshots/lowdown-$(VERSION).tar.gz
	$(INSTALL) -m 0444 lowdown.tar.gz.sha512 $(WWWDIR)/snapshots/lowdown-$(VERSION).tar.gz.sha512
	$(INSTALL) -m 0444 lowdown.tar.gz $(WWWDIR)/snapshots
	$(INSTALL) -m 0444 lowdown.tar.gz.sha512 $(WWWDIR)/snapshots

lowdown: liblowdown.a main.o
	$(CC) -o $@ main.o liblowdown.a $(LDFLAGS) $(LDADD_MD5) -lm

lowdown-diff: lowdown
	ln -f lowdown lowdown-diff

liblowdown.a: $(OBJS) $(COMPAT_OBJS)
	$(AR) rs $@ $(OBJS) $(COMPAT_OBJS)

liblowdown.so: $(OBJS) $(COMPAT_OBJS)
	$(CC) -shared -o $@.$(LIBVER) $(OBJS) $(COMPAT_OBJS) $(LDFLAGS) $(LDADD_MD5) -Wl,-soname,$@.$(LIBVER)
	ln -sf $@.$(LIBVER) $@

install: bins
	mkdir -p $(DESTDIR)$(BINDIR)
	mkdir -p $(DESTDIR)$(MANDIR)/man1
	mkdir -p $(DESTDIR)$(MANDIR)/man5
	mkdir -p $(DESTDIR)$(SHAREDIR)/lowdown/odt
	$(INSTALL_DATA) share/odt/styles.xml $(DESTDIR)$(SHAREDIR)/lowdown/odt
	$(INSTALL_PROGRAM) lowdown $(DESTDIR)$(BINDIR)
	$(INSTALL_PROGRAM) lowdown-diff $(DESTDIR)$(BINDIR)
	for f in $(MAN1S) $(MAN5S) ; do \
		name=`basename $$f .html` ; \
		section=$${name##*.} ; \
		$(INSTALL_MAN) man/$$name $(DESTDIR)$(MANDIR)/man$$section ; \
	done

install_lib_common: lowdown.pc
	mkdir -p $(DESTDIR)$(MANDIR)/man3
	mkdir -p $(DESTDIR)$(LIBDIR)/pkgconfig
	mkdir -p $(DESTDIR)$(INCLUDEDIR)
	$(INSTALL_DATA) lowdown.pc $(DESTDIR)$(LIBDIR)/pkgconfig
	$(INSTALL_DATA) lowdown.h $(DESTDIR)$(INCLUDEDIR)
	for f in $(MAN3S) ; do \
		name=`basename $$f .html` ; \
		section=$${name##*.} ; \
		$(INSTALL_MAN) man/$$name $(DESTDIR)$(MANDIR)/man$$section ; \
	done

install_shared: liblowdown.so install_lib_common
	$(INSTALL_LIB) liblowdown.so.$(LIBVER) $(DESTDIR)$(LIBDIR)

install_static: liblowdown.a install_lib_common
	$(INSTALL_LIB) liblowdown.a $(DESTDIR)$(LIBDIR)

install_libs: install_shared install_static

distcheck: lowdown.tar.gz.sha512
	mandoc -Tlint -Werror man/*.[135]
	newest=`grep "<h1>" versions.xml | tail -1 | sed 's![ 	]*!!g'` ; \
	       [ "$$newest" = "<h1>$(VERSION)</h1>" ] || \
		{ echo "Version $(VERSION) not newest in versions.xml" 1>&2 ; exit 1 ; }
	[ "`openssl dgst -sha512 -hex lowdown.tar.gz`" = "`cat lowdown.tar.gz.sha512`" ] || \
		{ echo "Checksum does not match." 1>&2 ; exit 1 ; }
	rm -rf .distcheck
	mkdir -p .distcheck
	( cd .distcheck && tar -zvxpf ../lowdown.tar.gz )
	( cd .distcheck/lowdown-$(VERSION) && ./configure PREFIX=prefix )
	( cd .distcheck/lowdown-$(VERSION) && $(MAKE) )
	( cd .distcheck/lowdown-$(VERSION) && $(MAKE) regress )
	( cd .distcheck/lowdown-$(VERSION) && $(MAKE) install )
	rm -rf .distcheck

$(PDFS) index.xml README.xml: lowdown

index.html README.html: template.xml

.md.pdf:
	./lowdown --nroff-no-numbered -s -tms $< | \
		pdfroff -i -mspdf -t -k > $@

index.latex.pdf: index.md $(THUMBS)
	./lowdown -s -tlatex index.md >index.latex.latex
	pdflatex index.latex.latex
	pdflatex index.latex.latex

index.mandoc.pdf: index.md
	./lowdown --nroff-no-numbered -s -tman index.md | \
		mandoc -Tpdf > $@

index.nroff.pdf: index.md
	./lowdown --nroff-no-numbered -s -tms index.md | \
		pdfroff -i -mspdf -t -k > $@

.xml.html:
	sblg -t template.xml -s date -o $@ -C $< $< versions.xml

archive.html: archive.xml versions.xml
	sblg -t archive.xml -s date -o $@ versions.xml

atom.xml: atom-template.xml versions.xml
	sblg -a -t atom-template.xml -s date -o $@ versions.xml

diff.html: diff.md lowdown
	./lowdown -s diff.md >$@

diff.diff.html: diff.md diff.old.md lowdown-diff
	./lowdown-diff -s diff.old.md diff.md >$@

diff.diff.pdf: diff.md diff.old.md lowdown-diff
	./lowdown-diff --nroff-no-numbered -s -tms diff.old.md diff.md | \
		pdfroff -i -mspdf -t -k > $@

$(HTMLS): versions.xml lowdown

.md.xml:
	( echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" ; \
	  echo "<article data-sblg-article=\"1\">" ; \
	  ./lowdown $< ; \
	  echo "</article>" ; ) >$@

.1.1.html .3.3.html .5.5.html:
	mandoc -Thtml -Ostyle=https://bsd.lv/css/mandoc.css $< >$@

lowdown.tar.gz.sha512: lowdown.tar.gz
	openssl dgst -sha512 -hex lowdown.tar.gz >$@

lowdown.tar.gz:
	mkdir -p .dist/lowdown-$(VERSION)/
	mkdir -p .dist/lowdown-$(VERSION)/man
	mkdir -p .dist/lowdown-$(VERSION)/share/odt
	mkdir -p .dist/lowdown-$(VERSION)/regress/original
	mkdir -p .dist/lowdown-$(VERSION)/regress/standalone
	mkdir -p .dist/lowdown-$(VERSION)/regress/metadata
	mkdir -p .dist/lowdown-$(VERSION)/regress/diff
	$(INSTALL) -m 0644 $(HEADERS) .dist/lowdown-$(VERSION)
	$(INSTALL) -m 0644 $(SOURCES) .dist/lowdown-$(VERSION)
	$(INSTALL) -m 0644 share/odt/* .dist/lowdown-$(VERSION)/share/odt
	$(INSTALL) -m 0644 lowdown.in.pc Makefile LICENSE.md .dist/lowdown-$(VERSION)
	$(INSTALL) -m 0644 man/*.1 man/*.3 man/*.5 .dist/lowdown-$(VERSION)/man
	$(INSTALL) -m 0755 configure .dist/lowdown-$(VERSION)
	$(INSTALL) -m 644 regress/original/* .dist/lowdown-$(VERSION)/regress/original
	$(INSTALL) -m 644 regress/*.* .dist/lowdown-$(VERSION)/regress
	$(INSTALL) -m 644 regress/standalone/* .dist/lowdown-$(VERSION)/regress/standalone
	$(INSTALL) -m 644 regress/metadata/* .dist/lowdown-$(VERSION)/regress/metadata
	$(INSTALL) -m 644 regress/diff/* .dist/lowdown-$(VERSION)/regress/diff
	( cd .dist/ && tar zcf ../$@ lowdown-$(VERSION) )
	rm -rf .dist/

$(OBJS) $(COMPAT_OBJS) main.o: config.h

$(OBJS): extern.h lowdown.h

term.o: term.h

main.o: lowdown.h

clean:
	rm -f $(OBJS) $(COMPAT_OBJS) main.o
	rm -f lowdown lowdown-diff liblowdown.a liblowdown.so liblowdown.so.$(LIBVER) lowdown.pc
	rm -f index.xml diff.xml diff.diff.xml README.xml lowdown.tar.gz.sha512 lowdown.tar.gz
	rm -f $(PDFS) $(HTMLS) $(THUMBS) $(VALGRINDS) $(VALGRINDDIFFS)
	rm -f index.latex.aux index.latex.latex index.latex.log index.latex.out

distclean: clean
	rm -f Makefile.configure config.h config.log config.h.old config.log.old

regress: bins
	tmp1=`mktemp` ; \
	tmp2=`mktemp` ; \
	for f in regress/original/*.text ; do \
		echo "$$f" ; \
		want="`dirname \"$$f\"`/`basename \"$$f\" .text`.html" ; \
		sed -e '/^[ ]*$$/d' "$$want" > $$tmp1 ; \
		./lowdown $(REGRESS_ARGS) "$$f" | \
			sed -e 's!	! !g' | sed -e '/^[ ]*$$/d' > $$tmp2 ; \
		diff -uw $$tmp1 $$tmp2 ; \
		./lowdown -s -thtml "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -tlatex "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -tman "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -tms "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -tfodt "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -tterm "$$f" >/dev/null 2>&1 ; \
		./lowdown -s -ttree "$$f" >/dev/null 2>&1 ; \
	done  ; \
	for f in regress/*.md ; do \
		echo "$$f" ; \
		if [ -f regress/`basename $$f .md`.html ]; then \
			./lowdown -thtml $$f >$$tmp1 2>&1 ; \
			diff -uw regress/`basename $$f .md`.html $$tmp1 ; \
		fi ; \

=== debian/changelog ===
lowdown (1.0.0-2) unstable; urgency=medium

  * Backport upstream patch to avoid the use of an -ms macro, PI, in the -Tman
    output. This addresses a man warning ("macro 'PI' not defined") which in
    turn is a lintian warning for packages using lowdown to generate their
    manpage(s).
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Faidon Liambotis <paravoid@debian.org>  Sun, 09 Apr 2023 03:39:15 +0300

lowdown (1.0.0-1) unstable; urgency=medium

  * New upstream release.
    - Refresh package description with upstream changes.
    - Override dh_auto_install to install the static library, as before, as
      the upstream "make install" now only installs the main binary.
    - Ship the new ODT styles.xml example as an example file in the main
      lowdown package.
  * Upstream now ships a shared library alongside the previous static one.
    Ship the library in a new liblowdown1 package, and adjust liblowdown-dev
    to Depend on it.
  * Add patch liblowdown-lm to fix an upstream issue where liblowdown.so was
    not linked with libm.
  * Add a temporary hack to pass a linker script to the shared library
    build, to hide symbols that were not meant to be exposed.
  * Mark lowdown as Multi-Arch: foreign. (Closes: #1023362)
  * Link against libmd directly, and not through the (now deprecated) libbsd
    wrappers for it. This adds a new Dependency, but one which was a
    transitive dependency before.
  * Add patch pkg-config-libmd-libbsd to add libmd and libbsd to
    Requires.private in pkg-config, as these are required when linking
    statically against liblowdown.a. (Closes: #1004541)
  * Build-Depend on pkgconf as the main alternative to pkg-config, retaining
    pkg-config to ease backports.
  * Update lintian-overrides to handle an upstream change in the wording of
    our existing override, and to add a new override for source-is-missing for
    regress/diff/diff.html, which is shipped alongside its Markdown source,
    and in fact generated by lowdown itself.
  * Add a couple of autopkgtest tests to ensure liblowdown works, by compiling
    a simple Markdown->HTML test program, executing it, and checking its
    output.
  * Bump Standards-Version to 4.6.1, no other changes needed.

 -- Faidon Liambotis <paravoid@debian.org>  Sat, 07 Jan 2023 06:52:41 +0200

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
  debhelper-compat (= 13),
  libbsd-dev,
  libmd-dev,
- pkg-config,
-Standards-Version: 4.6.0
+ pkgconf | pkg-config,
+Standards-Version: 4.6.2
 Section: text
 Homepage: https://kristaps.bsd.lv/lowdown/
 Vcs-Browser: https://salsa.debian.org/debian/lowdown
@@ -15,6 +15,7 @@
 
 Package: lowdown
 Architecture: any
+Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Simple markdown translator
  Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
@@ -32,13 +33,14 @@
   * metadata
   * commonmark (in progress)
   * definition lists
-  * extended image attributes
+  * extended attributes
+  * task lists
 
 Package: liblowdown-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}
+Depends: liblowdown1 (= ${binary:Version}), ${misc:Depends}
 Description: Simple markdown translator (development files)
  Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
  man formats, LaTeX, gemini, and terminal output.
@@ -55,6 +57,33 @@
   * metadata
   * commonmark (in progress)
   * definition lists
-  * extended image attributes
+  * extended attributes
+  * task lists
  .
  This package contains development libraries, header files, and manpages.
+
+Package: liblowdown1
+Section: libs
+Architecture: any
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: Simple markdown translator (shared library)
+ Lowdown is a Markdown translator producing HTML5, roff documents in the ms and
+ man formats, LaTeX, gemini, and terminal output.
+ .
+ Beyond traditional Markdown syntax support, lowdown supports the following
+ Markdown features and extensions:
+  * autolinking
+  * fenced code
+  * tables
+  * superscripts
+  * footnotes
+  * disabled inline HTML
+  * “smart typography”
+  * metadata
+  * commonmark (in progress)
+  * definition lists
+  * extended attributes
+  * task lists
+ .
+ This package contains the shared runtime library.

=== debian/tests/control ===
# Test whether the command-line executable works, by passing a well-known
# Markdown file to it.
Test-Command: lowdown LICENSE.md

# Test whether the static library works by compiling and running simple program
Tests: compile-run-static
Depends:
 build-essential,
 pkgconf | pkg-config,
 libmd-dev,
 libbsd-dev,
 liblowdown-dev,

# Test whether the shared library works by compiling and running simple program
Tests: compile-run-shared
Depends:
 build-essential,
 pkgconf | pkg-config,
 liblowdown-dev,

## lowdown 1.0.2

=== debian/changelog ===
lowdown (1.0.2-2) unstable; urgency=medium

  * Backport upstream commits to address the roff constant-width problem, i.e.
    the usage of the "C" font for roff, which as of groff 2.3.0 results into
    warning and, by extension, lintian warnings for downstream users.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 27 Oct 2023 17:24:44 +0300

lowdown (1.0.2-1) unstable; urgency=medium

  * New upstream release.
    - Drop patch dont-use-PI-for-tman, was an upstream backport.
    - Drop patch liblowdown-lm, merged upstream.
    - Drop manually installed liblowdown.so symlink, fixed upstream with
      commit f3cb4f31.
  * Add patch "revert-soname" to revert the SONAME to liblowdown.so.1, as the
    ABI has been stable and a library transition is not warranted.

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 01 Sep 2023 13:48:15 +0300
